/*********************************************************************************/
/********** THIS FILE IS GENERATED BY TOUCHGFX DESIGNER, DO NOT MODIFY ***********/
/*********************************************************************************/
#ifndef SCREEN1VIEWBASE_HPP
#define SCREEN1VIEWBASE_HPP

#include <gui/common/FrontendApplication.hpp>
#include <mvp/View.hpp>
#include <gui/screen1_screen/Screen1Presenter.hpp>
#include <touchgfx/widgets/Box.hpp>
#include <touchgfx/widgets/ScalableImage.hpp>
#include <touchgfx/widgets/TextArea.hpp>
#include <touchgfx/containers/buttons/Buttons.hpp>
#include <touchgfx/widgets/TextAreaWithWildcard.hpp>

class Screen1ViewBase : public touchgfx::View<Screen1Presenter>
{
public:
    Screen1ViewBase();
    virtual ~Screen1ViewBase() {}
    virtual void setupScreen();

    /*
     * Virtual Action Handlers
     */
    virtual void open_door()
    {
        // Override and implement this function in Screen1
    }

protected:
    FrontendApplication& application() {
        return *static_cast<FrontendApplication*>(touchgfx::Application::getInstance());
    }

    /*
     * Member Declarations
     */
    touchgfx::Box __background;
    touchgfx::ScalableImage scalableImage1;
    touchgfx::ScalableImage temp_ok;
    touchgfx::ScalableImage temp_no_ok;
    touchgfx::ScalableImage scalableImage2;
    touchgfx::TextArea textArea1;
    touchgfx::BoxWithBorderButtonStyle< touchgfx::ClickButtonTrigger > flexButton1;
    touchgfx::TextArea textArea2;
    touchgfx::TextAreaWithOneWildcard heater_status;
    touchgfx::TextAreaWithOneWildcard door_status;
    touchgfx::TextAreaWithOneWildcard temp_stauts;
    touchgfx::TextArea textArea3;
    touchgfx::TextAreaWithOneWildcard fan_status;
    touchgfx::TextArea textArea5;

    /*
     * Wildcard Buffers
     */
    static const uint16_t HEATER_STATUS_SIZE = 10;
    touchgfx::Unicode::UnicodeChar heater_statusBuffer[HEATER_STATUS_SIZE];
    static const uint16_t DOOR_STATUS_SIZE = 10;
    touchgfx::Unicode::UnicodeChar door_statusBuffer[DOOR_STATUS_SIZE];
    static const uint16_t TEMP_STAUTS_SIZE = 10;
    touchgfx::Unicode::UnicodeChar temp_stautsBuffer[TEMP_STAUTS_SIZE];
    static const uint16_t FAN_STATUS_SIZE = 10;
    touchgfx::Unicode::UnicodeChar fan_statusBuffer[FAN_STATUS_SIZE];

private:

    /*
     * Callback Declarations
     */
    touchgfx::Callback<Screen1ViewBase, const touchgfx::AbstractButtonContainer&> flexButtonCallback;

    /*
     * Callback Handler Declarations
     */
    void flexButtonCallbackHandler(const touchgfx::AbstractButtonContainer& src);

};

#endif // SCREEN1VIEWBASE_HPP
